'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var AppBar = function AppBar(_ref) {
  var _ref$color = _ref.color,
      color = _ref$color === undefined ? 'primary' : _ref$color,
      _ref$zDepth = _ref.zDepth,
      zDepth = _ref$zDepth === undefined ? 4 : _ref$zDepth,
      contentLeft = _ref.contentLeft,
      contentRight = _ref.contentRight,
      contentCenter = _ref.contentCenter,
      title = _ref.title;
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames3.default)('app-bar', _defineProperty({}, 'z-depth' + zDepth, zDepth))
    },
    _react2.default.createElement(
      _Paper2.default,
      {
        color: color,
        className: 'app-bar-container'
      },
      contentLeft && _react2.default.createElement(
        'div',
        { className: 'left-content' },
        contentLeft
      ),
      title && _react2.default.createElement(
        'div',
        { className: 'title' },
        title
      ),
      _react2.default.createElement(
        'div',
        { className: 'center-content' },
        contentCenter
      ),
      contentRight && _react2.default.createElement(
        'div',
        { className: 'right-content' },
        contentRight
      )
    )
  );
};

AppBar.propTypes = {
  color: _propTypes2.default.string,
  zDepth: _propTypes2.default.number,
  contentLeft: _propTypes2.default.node,
  contentCenter: _propTypes2.default.node,
  contentRight: _propTypes2.default.node,
  title: _propTypes2.default.string
};

exports.default = AppBar;