'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Avatar = function Avatar(_ref) {
  var bgc = _ref.bgc,
      icon = _ref.icon,
      src = _ref.src,
      size = _ref.size,
      style = _ref.style,
      other = _objectWithoutProperties(_ref, ['bgc', 'icon', 'src', 'size', 'style']);

  return _react2.default.createElement(
    'div',
    _extends({}, other, {
      style: _extends({}, style, { width: size, height: size, fontSize: size / 2 }),
      className: (0, _classnames3.default)('avatar', _defineProperty({}, 'bgc-' + bgc, bgc))
    }),
    icon ? _react2.default.createElement(_SvgIcon2.default, { icon: icon, size: size * 0.6, style: { margin: size * 0.2 } }) : _react2.default.createElement('img', { src: src })
  );
};

Avatar.defaultProps = {
  size: 40
};

Avatar.propTypes = {
  bgc: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  src: _propTypes2.default.string,
  size: _propTypes2.default.number,
  style: _propTypes2.default.object
};

exports.default = Avatar;