'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Ripple = require('../Ripple');

var _Ripple2 = _interopRequireDefault(_Ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Button.__proto__ || Object.getPrototypeOf(Button)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      cursorPos: {}
    }, _this.handleClick = function (event) {
      var cursorPos = {
        top: event.clientY,
        left: event.clientX,
        time: Date.now()
      };

      _this.setState({ cursorPos: cursorPos });

      if (typeof _this.props.onClick === 'function') _this.props.onClick(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$text = _props.text,
          text = _props$text === undefined ? 'button' : _props$text,
          _props$size = _props.size,
          size = _props$size === undefined ? 'm' : _props$size,
          _props$type = _props.type,
          type = _props$type === undefined ? 'raised' : _props$type,
          _props$icon = _props.icon,
          icon = _props$icon === undefined ? 'plus' : _props$icon,
          _props$color = _props.color,
          color = _props$color === undefined ? 'primary' : _props$color,
          disabled = _props.disabled,
          style = _props.style,
          className = _props.className;


      return _react2.default.createElement(
        'button',
        {
          style: style,
          disabled: disabled,
          onMouseDown: this.handleClick,
          className: (0, _classnames2.default)('btn', ['btn-' + size + ' btn-' + type + ' btn-' + color], className)
        },
        type === 'flat' || type === 'raised' ? text : null,
        type === 'icon' || type === 'fab' ? _react2.default.createElement(_SvgIcon2.default, { icon: icon }) : null,
        _react2.default.createElement(_Ripple2.default, { cursorPos: this.state.cursorPos })
      );
    }
  }]);

  return Button;
}(_react.Component);

Button.propTypes = {
  onClick: _propTypes2.default.func,
  text: _propTypes2.default.string,
  size: _propTypes2.default.string,
  type: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  color: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string
};

exports.default = Button;