'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = function (_Component) {
  _inherits(Card, _Component);

  function Card() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Card);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Card.__proto__ || Object.getPrototypeOf(Card)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      extendHeight: 0,
      extendContentHeight: 0
    }, _this.handleExtendClick = function () {
      var _this$state = _this.state,
          extendHeight = _this$state.extendHeight,
          extendContentHeight = _this$state.extendContentHeight;

      var newHeight = extendHeight > 0 ? 0 : extendContentHeight;
      _this.setState({ extendHeight: newHeight });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Card, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.refs.extend) {
        var offsetHeight = this.refs.extend.offsetHeight;

        this.setState({ extendContentHeight: offsetHeight + 40 });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          img = _props.img,
          actions = _props.actions,
          small = _props.small,
          actionsDivider = _props.actionsDivider,
          children = _props.children,
          extendableContent = _props.extendableContent,
          style = _props.style;
      var extendHeight = this.state.extendHeight;


      return _react2.default.createElement(
        _Paper2.default,
        {
          className: (0, _classnames2.default)('card', { 'card-small': small }),
          zDepth: 2,
          style: style
        },
        img ? _react2.default.createElement(
          'div',
          {
            style: img.parentStyle,
            className: (0, _classnames2.default)('card-img', { 'limited-height': img.parentStyle && img.parentStyle.maxHeight })
          },
          _react2.default.createElement('img', { style: img.childImgStyle, role: 'presentation', src: img.src }),
          img.caption && _react2.default.createElement(
            'span',
            { style: img.childCaptionStyle },
            img.caption
          )
        ) : null,
        _react2.default.createElement(
          'div',
          { className: 'card-content-wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'card-content' },
            children
          ),
          actions ? _react2.default.createElement(
            'div',
            {
              className: (0, _classnames2.default)('card-actions', { 'card-divider': actionsDivider })
            },
            actions,
            extendableContent ? _react2.default.createElement(_Button2.default, {
              type: 'icon',
              icon: 'chevron-up',
              color: 'black',
              className: (0, _classnames2.default)('extend-anchor', { open: extendHeight }),
              onClick: this.handleExtendClick
            }) : null
          ) : null,
          extendableContent ? _react2.default.createElement(
            'div',
            {
              style: { height: extendHeight + 'px' },
              className: (0, _classnames2.default)('extend', { open: extendHeight })
            },
            _react2.default.createElement(
              'div',
              { className: 'extend-wrapper' },
              _react2.default.cloneElement(extendableContent, {
                ref: 'extend'
              })
            )
          ) : null
        )
      );
    }
  }]);

  return Card;
}(_react.Component);

Card.propTypes = {
  img: _propTypes2.default.object,
  actions: _propTypes2.default.node,
  small: _propTypes2.default.bool,
  actionsDivider: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  extendableContent: _propTypes2.default.node,
  style: _propTypes2.default.object
};

exports.default = Card;