'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataRow = function DataRow(_ref) {
  var item = _ref.item,
      excludeKeys = _ref.excludeKeys,
      selected = _ref.selected,
      onIconClick = _ref.onIconClick,
      onRowClick = _ref.onRowClick,
      disabled = _ref.disabled,
      hideIcon = _ref.hideIcon,
      _ref$checkboxColor = _ref.checkboxColor,
      checkboxColor = _ref$checkboxColor === undefined ? 'accent' : _ref$checkboxColor;
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('data-table-body-row', 'selectable-row', 'is-selected-' + checkboxColor, {
        'is-selected': selected,
        'is-disabled': disabled,
        'is-clickable': hideIcon
      }),
      onClick: disabled ? function (noop) {
        return noop;
      } : onRowClick
    },
    !hideIcon && _react2.default.createElement(
      'div',
      {
        className: (0, _classnames2.default)('data-table-body-cell-icon', { 'is-disabled': disabled })
      },
      _react2.default.createElement(_SvgIcon2.default, {
        onClick: disabled ? function (noop) {
          return noop;
        } : onIconClick,
        icon: selected ? 'checkbox-marked' : 'checkbox-blank-outline'
      })
    ),
    Object.keys(item).map(function (prop, i) {
      return excludeKeys.indexOf(prop) === -1 ? _react2.default.createElement(
        'div',
        { key: i, className: 'data-table-body-cell' },
        item[prop]
      ) : null;
    })
  );
};

DataRow.propTypes = {
  item: _propTypes2.default.object,
  excludeKeys: _propTypes2.default.array,
  selected: _propTypes2.default.bool,
  onIconClick: _propTypes2.default.func,
  onRowClick: _propTypes2.default.func,
  disabled: _propTypes2.default.bool,
  hideIcon: _propTypes2.default.bool,
  checkboxColor: _propTypes2.default.string
};

exports.default = DataRow;