'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _DataHeader = require('./DataHeader');

var _DataHeader2 = _interopRequireDefault(_DataHeader);

var _DataRow = require('./DataRow');

var _DataRow2 = _interopRequireDefault(_DataRow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createOnClick = function createOnClick(fn, value) {
  return function (event) {
    return fn(value);
  };
};

var DataTable = function (_Component) {
  _inherits(DataTable, _Component);

  function DataTable() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DataTable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DataTable.__proto__ || Object.getPrototypeOf(DataTable)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedRows: [],
      disabledRows: [],
      ascending: false,
      scrollable: false,
      maxHeight: false
    }, _this.onRowClick = function (index) {
      var onRowClick = _this.props.onRowClick;
      var data = _this.state.data;

      if (onRowClick) {
        onRowClick(data[index], index);
      }
    }, _this.onSelectClick = function (index) {
      var _this$state = _this.state,
          maxSelected = _this$state.maxSelected,
          data = _this$state.data;
      var selectedRows = _this.state.selectedRows;

      var item = data[index];

      if (_this.isSelected(item)) {
        selectedRows.splice(selectedRows.indexOf(item), 1);
      } else if (maxSelected === 1) {
        selectedRows = [item];
      } else if (selectedRows.length >= maxSelected) {
        return;
      } else {
        selectedRows.push(item);
      }

      _this.setState({ selectedRows: selectedRows });
      _this.onChange(selectedRows);
    }, _this.onSelectAllRowsClick = function () {
      var _this$state2 = _this.state,
          selectedRows = _this$state2.selectedRows,
          disableSelectAll = _this$state2.disableSelectAll,
          data = _this$state2.data,
          disabledRows = _this$state2.disabledRows;

      var notAllSelected = selectedRows.length !== data.length - disabledRows.length;
      var newSelectedRows = [];

      if (disableSelectAll) return;

      if (notAllSelected) {
        newSelectedRows = [].concat(data).filter(function (item) {
          return disabledRows.indexOf(item) === -1;
        });
      }

      _this.setState({ selectedRows: newSelectedRows });
      _this.onChange(newSelectedRows);
    }, _this.sort = function (prop, headerIndex) {
      if (!_this.isSortable(prop)) return;

      var _this$state3 = _this.state,
          data = _this$state3.data,
          ascending = _this$state3.ascending;

      var sorted = void 0;

      if (ascending) {
        sorted = data.sort(function (a, b) {
          return a[prop] < b[prop];
        });
      } else {
        sorted = data.sort(function (a, b) {
          return a[prop] > b[prop];
        });
      }

      _this.setState({
        data: sorted,
        ascending: !ascending,
        sortActive: headerIndex
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DataTable, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.bindPropsToState(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.bindPropsToState(nextProps);
    }
  }, {
    key: 'onChange',
    value: function onChange(data) {
      if (this.props.onSelectedChange) {
        this.props.onSelectedChange(data);
      }
    }
  }, {
    key: 'bindPropsToState',
    value: function bindPropsToState(props) {
      var data = props.data,
          _props$disabledRows = props.disabledRows,
          disabledRows = _props$disabledRows === undefined ? [] : _props$disabledRows,
          maxSelected = props.maxSelected,
          withHeader = props.withHeader,
          withFooter = props.withFooter,
          maxHeight = props.maxHeight;


      var newData = [].concat(data);

      var disableSelectAll = props.disableSelectAll;


      if (maxSelected || !newData.length) disableSelectAll = true;

      var headersHeight = withHeader && withFooter ? 112 : 56;
      var maxRows = Math.floor((maxHeight - headersHeight) / 49);
      var roundedMaxHeight = maxHeight ? maxRows * 49 + headersHeight : false;

      this.setState({
        data: newData,
        disabledRows: disabledRows,
        maxSelected: maxSelected,
        disableSelectAll: disableSelectAll,
        headersHeight: headersHeight,
        maxHeight: roundedMaxHeight,
        scrollable: newData.length > maxRows
      });
    }
  }, {
    key: 'isSortable',
    value: function isSortable(prop) {
      var data = this.state.data;
      var sortableKeys = this.props.sortableKeys;

      return sortableKeys.indexOf(prop) !== -1 && data.length;
    }
  }, {
    key: 'isSelected',
    value: function isSelected(item) {
      return this.state.selectedRows.indexOf(item) !== -1;
    }
  }, {
    key: 'isDisabled',
    value: function isDisabled(item) {
      return this.state.disabledRows.indexOf(item) !== -1;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$withHeader = _props.withHeader,
          withHeader = _props$withHeader === undefined ? true : _props$withHeader,
          _props$withFooter = _props.withFooter,
          withFooter = _props$withFooter === undefined ? false : _props$withFooter,
          dataMock = _props.dataMock,
          excludeKeys = _props.excludeKeys,
          sortableKeys = _props.sortableKeys,
          _props$headerLabels = _props.headerLabels,
          headerLabels = _props$headerLabels === undefined ? [] : _props$headerLabels,
          _props$checkboxColor = _props.checkboxColor,
          checkboxColor = _props$checkboxColor === undefined ? 'accent' : _props$checkboxColor,
          _props$noDataMessage = _props.noDataMessage,
          noDataMessage = _props$noDataMessage === undefined ? 'No data to show' : _props$noDataMessage,
          onRowClick = _props.onRowClick;
      var _state = this.state,
          data = _state.data,
          ascending = _state.ascending,
          sortActive = _state.sortActive,
          selectedRows = _state.selectedRows,
          disabledRows = _state.disabledRows,
          disableSelectAll = _state.disableSelectAll,
          scrollable = _state.scrollable,
          maxHeight = _state.maxHeight,
          headersHeight = _state.headersHeight;


      var isAllSelected = selectedRows.length === data.length - disabledRows.length;
      var otherProps = maxHeight ? { style: { maxHeight: maxHeight - headersHeight } } : null;
      var headerProps = {
        ascending: ascending,
        sortActive: sortActive,
        scrollable: scrollable,
        dataMock: dataMock,
        excludeKeys: excludeKeys,
        headerLabels: headerLabels,
        sortableKeys: sortableKeys,
        dataLength: data.length,
        iconColor: checkboxColor,
        hideIcon: !!onRowClick,
        isAllSelected: isAllSelected,
        disableSelectAll: disableSelectAll,
        onIconClick: this.onSelectAllRowsClick,
        onSortClick: this.sort
      };

      return _react2.default.createElement(
        'div',
        { className: 'data-table-container' },
        withHeader && _react2.default.createElement(_DataHeader2.default, headerProps),
        _react2.default.createElement(
          'div',
          _extends({
            className: (0, _classnames2.default)('data-table-body', { scrollable: scrollable })
          }, otherProps),
          data.length ? data.map(function (item, key) {
            return _react2.default.createElement(_DataRow2.default, {
              key: key,
              item: item,
              excludeKeys: excludeKeys,
              selected: _this2.isSelected(item),
              disabled: _this2.isDisabled(item),
              hideIcon: !!onRowClick,
              checkboxColor: checkboxColor,
              onIconClick: createOnClick(_this2.onSelectClick, key),
              onRowClick: createOnClick(_this2.onRowClick, key)
            });
          }) : _react2.default.createElement(
            'div',
            { className: 'no-data-message' },
            noDataMessage
          )
        ),
        withFooter && _react2.default.createElement(_DataHeader2.default, _extends({}, headerProps, { bottom: true }))
      );
    }
  }]);

  return DataTable;
}(_react.Component);

DataTable.propTypes = {
  data: _propTypes2.default.array.isRequired,
  dataMock: _propTypes2.default.object.isRequired,
  onSelectedChange: _propTypes2.default.func,
  onRowClick: _propTypes2.default.func,
  withHeader: _propTypes2.default.bool,
  withFooter: _propTypes2.default.bool,
  excludeKeys: _propTypes2.default.array,
  sortableKeys: _propTypes2.default.array,
  headerLabels: _propTypes2.default.array,
  checkboxColor: _propTypes2.default.string,
  noDataMessage: _propTypes2.default.string
};

exports.default = DataTable;