'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Overlay = require('../Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dialog = function (_Component) {
  _inherits(Dialog, _Component);

  function Dialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      dialogShow: false,
      overlayShow: false,
      hasScroll: false
    }, _this.haveScroll = function () {
      var hasScroll = _this.state.hasScroll;
      var content = _this.refs.content;


      if (content == null) return;

      var contentScroll = content.scrollHeight > content.clientHeight;

      if (hasScroll !== contentScroll) {
        _this.setState({ hasScroll: contentScroll });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dialog, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var open = this.props.open;

      this.setState({ dialogShow: open, overlayShow: open });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.haveScroll();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      this.setState({ dialogShow: nextProps.open }, function () {
        _this2.setState({ overlayShow: nextProps.open }, _this2.haveScroll);
      });
    }
  }, {
    key: 'stopPropagation',
    value: function stopPropagation(event) {
      event.stopPropagation();
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _state = this.state,
          overlayShow = _state.overlayShow,
          dialogShow = _state.dialogShow,
          hasScroll = _state.hasScroll;
      var _props = this.props,
          requestClose = _props.requestClose,
          size = _props.size,
          type = _props.type,
          color = _props.color,
          alert = _props.alert,
          header = _props.header,
          children = _props.children,
          actions = _props.actions;

      return _react2.default.createElement(
        _Overlay2.default,
        {
          open: overlayShow,
          onRequestClose: requestClose
        },
        _react2.default.createElement(
          _Paper2.default,
          {
            zDepth: 24,
            type: type,
            color: color,
            className: (0, _classnames3.default)('dialog', (_classnames = {}, _defineProperty(_classnames, 'size-' + size, !alert), _defineProperty(_classnames, 'alert', alert), _defineProperty(_classnames, 'dialog-enter', dialogShow), _defineProperty(_classnames, 'dialog-leave', !dialogShow), _classnames)),

            onClick: this.stopPropagation
          },
          !!header && _react2.default.createElement(
            'div',
            {
              className: (0, _classnames3.default)('dialog-header', { 'z-depth1': hasScroll })
            },
            header
          ),
          _react2.default.createElement(
            'div',
            { ref: 'content', className: 'dialog-content' },
            children
          ),
          !!actions && _react2.default.createElement(
            'div',
            {
              className: (0, _classnames3.default)('dialog-actions', { 'actions-divider': hasScroll })
            },
            actions
          )
        )
      );
    }
  }]);

  return Dialog;
}(_react.Component);

Dialog.defaultProps = {
  requestClose: function requestClose() {},
  size: 'l'
};

Dialog.propTypes = {
  open: _propTypes.bool,
  requestClose: _propTypes.func,
  size: _propTypes.string,
  type: _propTypes.string,
  color: _propTypes.string,
  alert: _propTypes.bool,
  header: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node]),
  children: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node]),
  actions: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node])
};

exports.default = Dialog;