'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Overlay = require('../Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createOnClick = function createOnClick(fn, value) {
  return function (event) {
    return fn(value);
  };
};

var Drawer = function (_Component) {
  _inherits(Drawer, _Component);

  function Drawer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Drawer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Drawer.__proto__ || Object.getPrototypeOf(Drawer)).call.apply(_ref, [this].concat(args))), _this), _this.close = function (element, event) {
      var _this$props = _this.props,
          disableOverlayClick = _this$props.disableOverlayClick,
          disableDrawerLeftClick = _this$props.disableDrawerLeftClick,
          requestClose = _this$props.requestClose;


      if (element === 'overlay' && disableOverlayClick) return;
      if (element === 'leftDrawer' && disableDrawerLeftClick) return;
      requestClose(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Drawer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          overlay = _props.overlay,
          children = _props.children,
          open = _props.open;


      return _react2.default.createElement(
        'div',
        null,
        overlay ? _react2.default.createElement(_Overlay2.default, {
          open: open,
          onRequestClose: createOnClick(this.close, 'overlay')
        }) : null,
        _react2.default.createElement(
          'div',
          {
            onClick: createOnClick(this.close, 'leftDrawer'),
            className: (0, _classnames2.default)('drawer', 'z-depth16', { open: open })
          },
          children
        )
      );
    }
  }]);

  return Drawer;
}(_react.Component);

Drawer.propTypes = {
  open: _propTypes2.default.bool,
  overlay: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  disableOverlayClick: _propTypes2.default.bool,
  disableDrawerLeftClick: _propTypes2.default.bool,
  requestClose: _propTypes2.default.func.isRequired
};

exports.default = Drawer;