'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Ripple = require('../Ripple');

var _Ripple2 = _interopRequireDefault(_Ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItem = function (_Component) {
  _inherits(MenuItem, _Component);

  function MenuItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MenuItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MenuItem.__proto__ || Object.getPrototypeOf(MenuItem)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      cursorPos: {}
    }, _this.handleClick = function (event) {
      var cursorPos = {
        top: event.clientY,
        left: event.clientX,
        time: Date.now()
      };

      _this.setState({ cursorPos: cursorPos });

      if (typeof _this.props.onClick === 'function') _this.props.onClick(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MenuItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isHeader = _props.isHeader,
          isDivider = _props.isDivider,
          hoverable = _props.hoverable,
          rippable = _props.rippable,
          primaryText = _props.primaryText,
          secundaryText = _props.secundaryText,
          indentLeft = _props.indentLeft,
          indentRight = _props.indentRight,
          leftIcon = _props.leftIcon,
          rightIcon = _props.rightIcon,
          style = _props.style,
          className = _props.className;


      return _react2.default.createElement(
        'li',
        {
          onClick: this.handleClick,
          style: style,
          className: (0, _classnames2.default)('menu-item', {
            'is-header': isHeader,
            'is-divider': isDivider,
            hoverable: hoverable && !isDivider && !isHeader,
            'indent-left': (indentLeft || !!leftIcon) && !isDivider && !isHeader,
            'indent-right': (indentRight || !!rightIcon) && !isDivider && !isHeader
          }, className)
        },
        leftIcon && _react2.default.createElement(_SvgIcon2.default, { className: 'icon-left', size: 24, icon: leftIcon }),
        _react2.default.createElement(
          'span',
          {
            className: (0, _classnames2.default)('primary-text', { 'with-secundary-text': !!secundaryText })
          },
          primaryText
        ),
        secundaryText && _react2.default.createElement(
          'span',
          { className: 'secundary-text' },
          secundaryText
        ),
        rightIcon && _react2.default.createElement(_SvgIcon2.default, { className: 'icon-right', size: 24, icon: rightIcon }),
        rippable && _react2.default.createElement(_Ripple2.default, { cursorPos: this.state.cursorPos })
      );
    }
  }]);

  return MenuItem;
}(_react.Component);

MenuItem.propTypes = {
  isHeader: _propTypes2.default.bool,
  isDivider: _propTypes2.default.bool,
  hoverable: _propTypes2.default.bool,
  rippable: _propTypes2.default.bool,
  primaryText: _propTypes2.default.string,
  secundaryText: _propTypes2.default.string,
  indentLeft: _propTypes2.default.bool,
  indentRight: _propTypes2.default.bool,
  leftIcon: _propTypes2.default.node,
  rightIcon: _propTypes2.default.node,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func
};

exports.default = MenuItem;