'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Paper = function Paper(_ref) {
  var zDepth = _ref.zDepth,
      type = _ref.type,
      color = _ref.color,
      children = _ref.children,
      style = _ref.style,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['zDepth', 'type', 'color', 'children', 'style', 'className']);

  var depth = zDepth > 0 && zDepth <= 24;

  return _react2.default.createElement(
    'div',
    _extends({
      style: style,
      className: (0, _classnames4.default)('paper', 'bgc-' + color, _defineProperty({}, 'paper-' + type, type), _defineProperty({}, 'z-depth' + zDepth, depth), className)
    }, props),
    children
  );
};

Paper.defaultProps = {
  zDepth: 0,
  color: 'white'
};

Paper.propTypes = {
  zDepth: _propTypes.number,
  type: _propTypes.string,
  color: _propTypes.string,
  style: _propTypes.object,
  children: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node]),
  className: _propTypes.string
};

exports.default = Paper;