'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Ripple = function (_Component) {
  _inherits(Ripple, _Component);

  function Ripple() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Ripple);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Ripple.__proto__ || Object.getPrototypeOf(Ripple)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      animate: false,
      width: 0,
      height: 0,
      top: 0,
      left: 0
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Ripple, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var cursorPos = nextProps.cursorPos;
      if (cursorPos.time !== this.props.cursorPos.time) {
        if (this.state.animate) {
          this.setState({ animate: false }, function () {
            _this2.rippling(cursorPos);
          });
        } else this.rippling(cursorPos);
      }
    }
  }, {
    key: 'rippling',
    value: function rippling(cursorPos) {
      var rippleElement = this.ripple;
      var parent = rippleElement.parentElement;

      var parentPos = parent.getBoundingClientRect();

      var parentWidth = parent.offsetWidth;
      var parentHeight = parent.offsetHeight;

      var diameter = Math.max(parentHeight, parentWidth);
      var center = diameter / 2;

      this.setState({
        animate: true,
        width: diameter + 'px',
        height: diameter + 'px',
        top: cursorPos.top - parentPos.top - center + 'px',
        left: cursorPos.left - parentPos.left - center + 'px'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          top = _state.top,
          left = _state.left,
          width = _state.width,
          height = _state.height;

      return _react2.default.createElement('span', {
        className: 'ripple ' + (this.state.animate ? 'ripple--is-animated' : ''),
        ref: function ref(node) {
          _this3.ripple = node;
        },
        style: { top: top, left: left, width: width, height: height }
      });
    }
  }]);

  return Ripple;
}(_react.Component);

Ripple.propTypes = {
  cursorPos: _propTypes2.default.object.isRequired
};

exports.default = Ripple;