'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _iconPaths = require('./iconPaths');

var _iconPaths2 = _interopRequireDefault(_iconPaths);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Svg = function Svg(_ref) {
  var size = _ref.size,
      color = _ref.color,
      icon = _ref.icon,
      onClick = _ref.onClick,
      other = _objectWithoutProperties(_ref, ['size', 'color', 'icon', 'onClick']);

  return _react2.default.createElement(
    'svg',
    _extends({ width: size, height: size, fill: color, viewBox: '0 0 24 24', onClick: onClick }, other),
    _react2.default.createElement('path', { d: _iconPaths2.default[icon] })
  );
};

Svg.propTypes = {
  size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  color: _propTypes2.default.string,
  icon: _propTypes2.default.string.isRequired,
  onClick: _propTypes2.default.func
};

exports.default = Svg;