'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames4 = require('classnames');

var _classnames5 = _interopRequireDefault(_classnames4);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextField = function (_Component) {
  _inherits(TextField, _Component);

  function TextField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextField.__proto__ || Object.getPrototypeOf(TextField)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      focused: !!(_this.props.value && _this.props.value.toString().length)
    }, _this.handleChange = function (event) {
      var value = event.target.value;

      _this.props.onChange(value, event);
    }, _this.clear = function () {
      _this.props.onChange('');

      if (_this.props.multiRow) {
        _this.textarea.focus();
      } else {
        _this.input.focus();
      }
    }, _this.focus = function () {
      _this.setState({
        focused: true
      });
    }, _this.blur = function () {
      if (!_this.props.value) {
        _this.setState({
          focused: false
        });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextField, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.textarea) {
        var scrollHeight = this.textarea.scrollHeight;

        this.setState({
          originalTextareaHeight: scrollHeight,
          textareaHeight: scrollHeight
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var multiRow = nextProps.multiRow;
      var originalTextareaHeight = this.state.originalTextareaHeight;


      if (multiRow) {
        this.setState({
          textareaHeight: originalTextareaHeight
        }, function () {
          _this2.setState({ textareaHeight: _this2.textarea.scrollHeight });
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames,
          _classnames2,
          _this3 = this,
          _classnames3;

      var _state = this.state,
          focused = _state.focused,
          textareaHeight = _state.textareaHeight;
      var _props = this.props,
          value = _props.value,
          _props$label = _props.label,
          label = _props$label === undefined ? 'label' : _props$label,
          hint = _props.hint,
          multiRow = _props.multiRow,
          _props$color = _props.color,
          color = _props$color === undefined ? 'primary' : _props$color,
          _props$errorColor = _props.errorColor,
          errorColor = _props$errorColor === undefined ? 'red' : _props$errorColor,
          _props$successColor = _props.successColor,
          successColor = _props$successColor === undefined ? 'green' : _props$successColor,
          limit = _props.limit,
          icon = _props.icon,
          _props$type = _props.type,
          type = _props$type === undefined ? 'text' : _props$type,
          allowClear = _props.allowClear,
          disabled = _props.disabled,
          error = _props.error,
          success = _props.success,
          limitError = _props.limitError,
          limitSuccess = _props.limitSuccess,
          helpMessage = _props.helpMessage;
      var fixedLabel = this.props.fixedLabel;


      if (icon) fixedLabel = true;

      return _react2.default.createElement(
        'div',
        { className: 'text-field-root' },
        icon && _react2.default.createElement(
          'div',
          {
            className: (0, _classnames5.default)('icon-container', (_classnames = {}, _defineProperty(_classnames, 'icon-color-' + color, !error && !limitError && !success && !limitSuccess && !disabled), _defineProperty(_classnames, 'icon-color-' + errorColor, (error || limitError) && !disabled), _defineProperty(_classnames, 'icon-color-' + successColor, (success || limitSuccess) && !disabled), _defineProperty(_classnames, 'focused', focused), _classnames))
          },
          _react2.default.createElement(_SvgIcon2.default, { icon: icon })
        ),
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames5.default)('text-field', (_classnames2 = {}, _defineProperty(_classnames2, 'text-field-color-' + color, !error && !limitError && !success && !limitSuccess && !disabled), _defineProperty(_classnames2, 'text-field-color-' + errorColor, (error || limitError) && !disabled), _defineProperty(_classnames2, 'text-field-color-' + successColor, (success || limitSuccess) && !disabled), _defineProperty(_classnames2, 'text-field-label-is-fixed', fixedLabel), _defineProperty(_classnames2, 'text-field-have-icon', !!icon), _defineProperty(_classnames2, 'text-field-is-disabled', disabled), _defineProperty(_classnames2, 'focused', focused), _classnames2))
          },
          _react2.default.createElement(
            'span',
            {
              className: (0, _classnames5.default)({
                'text-field-label': !fixedLabel,
                'text-field-label-fixed': fixedLabel,
                'hide-label': fixedLabel && value.toString().length
              })
            },
            label
          ),
          allowClear && focused && !!value.toString().length && _react2.default.createElement(
            'div',
            {
              className: 'clear',
              onClick: this.clear
            },
            _react2.default.createElement(_SvgIcon2.default, { icon: 'close-circle' })
          ),
          multiRow ? _react2.default.createElement('textarea', {
            className: 'text-field-input',
            placeholder: focused && !fixedLabel ? hint : '',
            value: value,
            ref: function ref(node) {
              _this3.textarea = node;
            },
            style: { height: textareaHeight },
            onChange: this.handleChange,
            onFocus: this.focus,
            onBlur: this.blur
          }) : _react2.default.createElement('input', {
            className: 'text-field-input',
            placeholder: focused && !fixedLabel ? hint : '',
            type: type,
            value: value,
            ref: function ref(node) {
              _this3.input = node;
            },
            onChange: this.handleChange,
            onFocus: this.focus,
            onBlur: this.blur
          })
        ),
        _react2.default.createElement(
          'div',
          { className: 'text-field-help' },
          (error || success) && helpMessage && _react2.default.createElement(
            'div',
            {
              className: (0, _classnames5.default)('help-message-' + errorColor)
            },
            helpMessage
          ),
          limit && _react2.default.createElement(
            'div',
            {
              className: (0, _classnames5.default)('limit', (_classnames3 = {}, _defineProperty(_classnames3, 'limit-' + errorColor, limitError && focused && !disabled), _defineProperty(_classnames3, 'limit-' + successColor, limitSuccess && focused && !disabled), _classnames3))
            },
            value.toString().length + '/' + limit
          )
        )
      );
    }
  }]);

  return TextField;
}(_react.Component);

TextField.propTypes = {
  allowClear: _propTypes2.default.bool,
  color: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  error: _propTypes2.default.bool,
  errorColor: _propTypes2.default.string,
  helpMessage: _propTypes2.default.string,
  hint: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  label: _propTypes2.default.string,
  limit: _propTypes2.default.number,
  limitError: _propTypes2.default.bool,
  limitSuccess: _propTypes2.default.bool,
  multiRow: _propTypes2.default.bool,
  onChange: _propTypes2.default.func.isRequired,
  success: _propTypes2.default.bool,
  successColor: _propTypes2.default.string,
  style: _propTypes2.default.object,
  type: _propTypes2.default.string,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
  fixedLabel: _propTypes2.default.bool
};

exports.default = TextField;