'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Toolbar = function Toolbar(_ref) {
  var contentLeft = _ref.contentLeft,
      contentRight = _ref.contentRight,
      label = _ref.label,
      zDepth = _ref.zDepth,
      color = _ref.color,
      type = _ref.type;
  return _react2.default.createElement(
    _Paper2.default,
    {
      className: 'toolbar',
      zDepth: zDepth,
      type: type,
      color: color
    },
    !!contentLeft && _react2.default.createElement(
      'div',
      { className: 'toolbar-left' },
      contentLeft
    ),
    !!label && _react2.default.createElement(
      'span',
      { className: 'toolbar-label' },
      label
    ),
    !!contentRight && _react2.default.createElement(
      'div',
      { className: 'toolbar-right' },
      contentRight
    )
  );
};

Toolbar.defaultProps = {
  color: 'primary'
};

Toolbar.propTypes = {
  contentLeft: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node]),
  contentRight: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node]),
  label: _propTypes.string,
  zDepth: _propTypes.number,
  type: _propTypes.string,
  color: _propTypes.string
};

exports.default = Toolbar;